Subject: Re: [PATCH] dnet: Dave DNET ethernet controller driver

From: Neil Horman <[email-masked]>
Date: Thu, 12 Mar 2009 20:16:03 -0400

On Thu, Mar 12, 2009 at 09:59:19PM +0000, Jamie Lokier wrote:
> Neil Horman wrote:
> > I've not looked at the figures lately, but how much space does the
> > dhcp client and nfs root code take up in the kernel these days?
> 
> About 4k apparently.  See the difference from "400k compressed?".
> Also, uncompressing that may add 0.5 second boot time on a slow CPU :-)
> 
> > I sympathize with you.  This is exactly what soured me on embedded
> > work a few years back.  Embedded shops are forever compromising
> > doing things correctly in the name of time and schedules, never
> > paying any heed to the possibility that taking extra time to do
> > things in an agreed upon, organized and standard fashion might pay
> > off for them in the long run.
> 
> I must admit that a solution which makes the effective kernel size
> 800k larger (your figure) doesn't look like a good standard to me.
> 
> If that was the "standard", I'd be tempted to add a MAC address driver
> hack to the kernel to save the space :-)
> 
> -- Jamie
> 
I agree that the simple 8k savings is less than stellar, but if you're setting
up a development environment over NFS root, your savings are really unbounded.
Need more space?  Carve out a config option in the kernel that you don't need
immediately, build it as a module, and store it on the NFS root, keeping only
the needed functionality for NFS root in the monolithic image.  Lather, rinse,
repeat until you have enough space.